(function () {
    "use strict";

    angular.module('core').controller('gradeDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', 'lookupService', '$state', '$stateParams', 'gradeService', '$alert'];

    function controller($scope, $timeout, $q, lookupService, $state, $stateParams, gradeService, $alert) {
        $scope.initializeLayout('Grade');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Posicoes: 1,
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.auxiliar = {
            tipograde: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoGrade({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };


        $scope.save = function () {
            $scope.state.salvando = true;
            gradeService
                .save($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.state.salvando = false;
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.historyBack();
                    }
                },
                function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        }


        $scope.auxiliar = {
            posicao: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    gradeService
                        .prepareNewPosicao($scope.state.item)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item = response.Data;
                            }
                            $scope.state.vazio = !$scope.state.item;
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                }
            },
            tipograde: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoGrade({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };


        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            gradeService
                .get($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.item = response.Data;
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = !$scope.state.item;
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();